package AOPRolePermissions;

/// A class for tracking CRUD permissions
///   C - create
///   R - read
///   U - update
///   d - delete
public class Permission
{
	// Constructor
	public Permission(String inFieldName, byte inPermissions)
	{
		FieldName = inFieldName;
		Permissions = inPermissions;
	}
	
	public Permission(String inFieldName, Permission.Type inPermissionType)
	{
		FieldName = inFieldName;
		addPermission(inPermissionType);
	}

	// Permissions
	private byte Permissions;

	public void addPermission(Permission.Type inType)
	{
		Permissions = (byte) (Permissions | inType.value);
	}

	public void removePermission(Permission.Type inType)
	{
		if (can(inType))
		{
			Permissions = (byte) (Permissions ^ inType.value);
		}
	}

	// FieldName
	private String FieldName = "";

	public String getFieldName()
	{
		return FieldName;
	}

	public void setFieldName(String fieldName)
	{
		FieldName = fieldName;
	}

	// Permission Evaluator
	public boolean can(Permission.Type inType)
	{
		if (inType.value == 0)
			return Permissions == 0;
		return (Permissions & inType.value) == inType.value;
	}

	// Permission Type
	public enum Type
	{
		All((byte) 15), Create((byte) 8), Read((byte) 4), Update((byte) 2), Delete(
				(byte) 1), None((byte) 0);

		public final byte value;

		Type(byte inValue)
		{
			this.value = inValue;
		}
	}
}
